import requests
import json
import collections
import arcpy
import os
from JsonParameters import RootObject
from JsonRouteParameters import RouteParameter
from jsonResponse import ResponseParameters
import dateutil.parser
import datetime
import uuid
import random
import json
import os
from multiprocessing import Process
import copy
import urllib.parse
import urllib.request
import pytz
import certifi
from urllib.parse import urlparse

APP_ID = "d8e9df9d" 
API_KEY = "8a062f21f574e7918700ff2feba8fa98"
sr = arcpy.SpatialReference(4326)
arrival = None
departure = None
location = None
wgs = arcpy.SpatialReference(4326)
parameters = arcpy.GetParameterInfo()
transpotations = {};
scriptPath = sys.argv[0]
toolSharePath = os.path.dirname(os.path.dirname(scriptPath))
dataPath = os.path.join(toolSharePath, 'iGeolise')
queryCount=0
parametersList = list()
requestlist = list()

for params in parameters:
    parametersList.append(str(params.value).split(";")) 

advParaList = ['','Name','UTC','departure','','public_transport','','Name','','','0', '15', '30', '15', '5', '0', '0']
simpleParaList = ['','public_transport','UTC','departure','','','']


if len(parametersList[0]) == 8:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(simpleParaList[idx])
        paramlist.append(objectlist)
else:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(advParaList[idx])
        paramlist.append(objectlist)



res =  paramlist

arcpy.AddMessage("Processing algorithm…") 
arcpy.AddMessage("Algorithm 'Routes - Simple' starting…") 
arcpy.AddMessage("Input parameters: {}".format(res)) 
arcpy.AddMessage("TravelTime Plugin Version : 1.0.1")
arcpy.AddMessage("TravelTime Algorithm : RouteAlgorithm")

    


    
def loadJson(jsonResponse,feature):		
    jsonResult = jsonResponse #.json()  # json.loads( jsonResponse, object_pairs_hook= ResponseParameters)      
    
    try:
        i = 0; 
        for Jresults in jsonResult['results']:            
            search_id = Jresults['search_id'].split('-')                
            for loc in Jresults['locations']:    
                if Output_style.replace("'","") != "By transport type" :
                    coord = list()
                totalTime = 0
                totalDistance = 0
                for parts in loc['properties'][0]['route']['parts']:
                    if Output_style.replace("'","") == "By transport type" :
                        coord = list()
                    for geom in parts['coords']:
                        geometry = [geom['lng'],geom['lat']]
                        coord.append(geometry)
                    totalTime += int(parts['travel_time'])
                    totalDistance +=  parts['distance']
                    try:
                        if Output_style.replace("'","") == "By transport type" :
                            feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"type": parts['type'],"mode": parts['mode'],"directions": parts['directions'],"direction": None,"travel_time": parts['travel_time'],"turn":None,"distance": parts['distance'] }})                    
                            i=i+1
                    except:
                        #i=i+1
                        arcpy.AddMessage("gemoetry is empty.")
                try:
                    if Output_style.replace("'","") != "By transport type":
                        if search_type == "departure":
                            feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"search_id":search_id[0],"location_id":loc['id'],"travel_time": totalTime/60,"turn":None,"distance":totalDistance,"Label":"from "+search_id[0]+" to "+loc['id']}})
                        else :
                            feature.append({"type": "Feature","id":"destination","geometry": {"type": "LineString","coordinates":coord},"properties": {"FID": i,"id": parts['id'],"search_id":search_id[0],"location_id":loc['id'],"travel_time": totalTime/60,"turn":None,"distance":totalDistance,"Label":"From "+loc['id']+" to "+search_id[0]}})
                        i=i+1
                except :
                    #i=i+1
                    arcpy.AddMessage("gemoetry is empty")
                    #exit(0)
        return feature
        arcpy.AddWarning("Reached till features")
    except KeyError:        
        arcpy.AddWarning("Error {}".format(jsonResult))
        return feature

def parseRequest(requestParameter,APP_ID,API_KEY,Output_style,customize_endpoint):       
    index =uuid.uuid1()
    featureCollections = list()
             
    API_ENDPOINT = customize_endpoint+"/v4/routes"
    headers = {
        'Accept': "application/json",
        'X-Application-Id': APP_ID,
        'X-Api-Key': API_KEY,
        'Content-Type': "application/json",
        'User-Agent' : "ArcGIS Pro v1.0"
        }
    feature = list()
    featureCollection = list()
    for request in requestParameter:
        endpoint=urlparse(customize_endpoint)
        try:
            if endpoint.scheme=="https":
                req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                res = json.loads(urllib.request.urlopen(req,cafile=certifi.where()).read().decode('utf-8'))
                features = loadJson(res,feature)
            elif endpoint.scheme=='http':
                req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                res = json.loads(urllib.request.urlopen(req).read().decode('utf-8'))
                features = loadJson(res,feature)
        except Exception:
            e= sys.exc_info()[1]
            arcpy.AddError('An error occurred: {}'.format(e.args[0]))
            #exit(0)

   
    featureCollection.append({"type":"FeatureCollection","features":features}) 
    outputFilePath =  os.path.join(dataPath, 'output.json')
    with open(outputFilePath,'w+') as f:	
        json.dump(featureCollection[0], f)  	
    
    try:       
        arcpy.env.overwriteOutput = True
        arcpy.env.addOutputsToMap = False
        results = arcpy.JSONToFeatures_conversion(outputFilePath,Output_layer ,'POLYLINE')
       # arcpy.AddMessage(results)
        getRendering(outputFilePath,Output_layer,Output_style)
    except:
        e = sys.exc_info()[1]
        arcpy.AddError('An error occurred: {}'.format(e.args[0]))
    #time.sleep(5)
   


def unique(list1):
  
    # intilize a null list 
    unique_list = [] 
      
    # traverse for all elements 
    for x in list1: 
        # check if exists in unique_list or not 
        if x not in unique_list and x is not 0: 
            unique_list.append(x)
    return unique_list

def getRendering(outputFilePath,Output_layer,Output_style):
    try:
        
        if Output_style.replace("'","") == "By journey" : 
            layerName = (arcpy.Describe(Output_layer)).baseName
            p = arcpy.mp.ArcGISProject('CURRENT')
            m = p.listMaps('Map')[0]        
            m.addDataFromPath(Output_layer)
            lyr = m.listLayers(layerName)
            for l in lyr:                    
                if l.name == layerName :                    
                    sym = l.symbology
                    sym.updateRenderer('UniqueValueRenderer')
                    sym.renderer.fields = ['Label']            
                    for grp in sym.renderer.groups:
                        for itm in grp.items:
                            transVal = itm.label #Grab the first "percent" value in the list of potential values
                            itm.symbol.color = getRGB()
                            itm.symbol.size = 2 
                            
                l.symbology = sym
                time.sleep(5)                
                             
        elif Output_style.replace("'","") == "By transport type" :                   
            TransportPolyLineLyrPath = os.path.join(dataPath, 'DetailedRouteSymbols.lyrx')
            Transportparams = arcpy.GetParameterInfo()
            Transportdesc = arcpy.Describe(Output_layer)            
            Transportparams[symbol_index].symbology = TransportPolyLineLyrPath            
                     
            time.sleep(5) 

        elif Output_style.replace("'","") == "By travel time" :
            results = arcpy.JSONToFeatures_conversion(outputFilePath,Output_layer ,'POLYLINE')
            layerName = (arcpy.Describe(Output_layer)).baseName
            p = arcpy.mp.ArcGISProject('CURRENT')
            m = p.listMaps('Map')[0]        
            m.addDataFromPath(Output_layer)
            lyr = m.listLayers(layerName)
            for l in lyr:                    
                 if l.name == layerName :
                    classBreakValues = [5.0,15.0,30.0,60.0,120.0,300.0,14400]
                    classBreakLowerValues = [0, 5, 15, 30, 60, 120, 300]
                    classBreakLabels = ["0-5 min", "5-15 min", "15-30 min", "30-60 min", "1-2 hrs","2-5 hrs",">5 hrs"]
                    classBreakLColor = [{'RGB': [255, 238, 5, 100]}, {'RGB': [255, 159, 5, 100]}, {'RGB': [255, 93, 5, 100]}, {'RGB': [245, 5, 5, 100]}, {'RGB': [204, 0, 0, 100]}, {'RGB': [168, 0, 20, 100]}, {'RGB': [87, 0, 64, 100]}]
                    sym = l.symbology
                    if sym.renderer.type == 'SimpleRenderer':
                        sym.updateRenderer('GraduatedColorsRenderer')
                        sym.renderer.breakCount = len(classBreakValues)
                        sym.renderer.classificationField = 'travel_time'
                        sym.renderer.nomalizationType  = '<None>'
                        sym.renderer.numClasses  = '7'
                        #sym.renderer.classificationMethod='GeometricInterval'
                        idxlist = list()
                        for brk in sym.renderer.classBreaks:
                            breakval = round(float(brk.label[1:]))
                            idx = classBreakLowerValues.index(classBreakLowerValues [min(range(len(classBreakLowerValues )), key = lambda i: abs(classBreakLowerValues [i]-breakval))])
                            idxlist.append(idx)
                        sym.renderer.breakCount  = len(unique(idxlist))
                        #sym.renderer.colorRamp = p.listColorRamps('Yellow to Red')[0]
                        uniquelist = unique(idxlist)
                        count = 0
                        for brk in sym.renderer.classBreaks:
                            breakval = round(float(brk.label[1:]))
                            idx = classBreakLowerValues.index(classBreakLowerValues [min(range(len(classBreakLowerValues )), key = lambda i: abs(classBreakLowerValues [i]-breakval))])
                            brk.upperBound = classBreakValues[uniquelist[count]]
                            brk.label = classBreakLabels[uniquelist[count]]
                            brk.symbol.color = classBreakLColor[uniquelist[count]]
                            count += 1
                    #sym = params[symbol_index].symbology
                    l.symbology = sym
                   
            time.sleep(5) 
    except Exception:
        e = sys.exc_info()[1]
        arcpy.AddWarning('An error occurred: {}'.format(e.args[0]))
        arcpy.AddWarning("Failed to renderer symbology. Please try again")


def getRGB():
    red = random.randint(0,255)
    g = random.randint(0,255)
    b = random.randint(0,255)
    a = random.randint(200,255)
    return  {'RGB':  [red,g, b, a]} 


for para in res:
    if len(parameters) == 8 :
        departure_search = para[0].replace("'","")
        search_type = para[3].replace("'","")  
        Transportation_type = para[1].replace("'","")
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        location_search = para[5].replace("'","")  
        Output_style = para[6].replace("'","")
        Output_layer = para[7].replace("'","")
        transpotations["type"] = Transportation_type
        symbol_index = 7
        Search_range_width= 1800
    else :
        departure_search = para[0].replace("'","")
        Departure_ID = para[1].replace("'","")
        search_type = para[3].replace("'","")   
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        Transportation_type = para[5].replace("'","")   
        location_search = para[6].replace("'","")  
        location_id = para[7].replace("'","")  
        Output_style = para[8].replace("'","")
        Output_layer = para[9].replace("'","")
        change_delay = para[10].replace("'","")
        walking_time= para[11].replace("'","")
        driving_time_to_station= para[12].replace("'","")
        cycling_time_to_station= para[13].replace("'","")
        parking_time= para[14].replace("'","")
        boarding_time= para[15].replace("'","")
        Search_range_width= int(para[16].replace("'",""))*60

        transpotations["type"] = Transportation_type
        transpotations["pt_change_delay"] = int(change_delay)*60
        transpotations["walking_time"] = int(walking_time)*60
        transpotations["driving_time_to_station"] = int(driving_time_to_station)*60
        transpotations["cycling_time_to_station"] = int(cycling_time_to_station)*60
        transpotations["parking_time"] = int(parking_time)*60
        transpotations["boarding_time"] = int(boarding_time)*60
        #transpotations["Search_range_width"] = int(Search_range_width)*60
        symbol_index = 9

    #tzinfo = arcpy.time.TimeZoneInfo(Time_zone) 
    #travel_time= Date_time.astimezone(tzinfo)    
    tzinfo = pytz.timezone(Time_zone)    
    travel_time = (tzinfo.localize(Date_time)).isoformat()

    arcpy.env.overwriteOutput = True
    arcpy.env.addOutputsToMap = False
    Req = list ()
    departure_id =list()
    arrival_ids =list()
    arrival_ids_chunk =list()
    departure_searches = list()
    arrival_searches = list()

    
    contentPath=r"C:\Users\GL1027\AppData\Local\ESRI\ArcGISPro\AssemblyCache\{93b669fa-2cff-4462-8a31-2b9695d5c63c}\Python"    
    authenticatoinFilePath =  os.path.join(toolSharePath, 'Authentication.json') # "..//Authentication.json"
   
    try:
        with open(authenticatoinFilePath) as f:
          data = json.load(f)          
          if  '' in [data['Api_key'], data['App_id']]:
              arcpy.AddError("Error: You need a TravelTime platform API key to make requests. Please head to http://docs.traveltimeplatform.com/overview/getting-keys/ to obtain one, and enter it in the plugin's setting dialog.")
              exit(0)
          else:
            APP_ID =  data['App_id']
            API_KEY = data['Api_key']
            customize_endpoint = data['customize_endpoint']
           
            arrival_ids =list()
            Source = list()
            ApiCount = 0
            prop = list(["travel_time", "distance", "route"])
            locations = list()
            ### arrival locations
            for row in arcpy.da.SearchCursor(location_search, ["OID@", "SHAPE@"]):        
                pnt_wgs = row[1].projectAs(wgs)
                id_search = "searches" + str(row[0])
                arrival_ids.append("searches" + str(row[0]))                
                locations.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
 
            n=2
            m=20
            final = [locations[i * m:(i + 1) * m] for i in range((len(locations) + m - 1) // m )]  
            arrival_ids_chunk = [arrival_ids[i * n:(i + 1) * n] for i in range((len(arrival_ids) + n - 1) // n )]              
            reuest_list = list()
    
            ### departure location 
            departure_search_list = list()
            departureList = list()
            departure_ids =list()
            for row in arcpy.da.SearchCursor(departure_search, ["OID@", "SHAPE@"]):                     
                departure_search_id = "Location" + str(row[0])  
                departure_ids.append(departure_search_id)
                pnt_wgs = row[1].projectAs(wgs)                
                departureList.append({"id":departure_search_id,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
                locations.append({"id":departure_search_id,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
           
                           
            n=2
            m=20
            dfinal = [departureList[i * m:(i + 1) * m] for i in range((len(departureList) + m - 1) // m )]  
            departure_ids_chunk = [departure_ids[i * n:(i + 1) * n] for i in range((len(departure_ids) + n - 1) // n )]  

            if search_type == "departure":
                reuest_list = list()
                for departure_id in departure_ids:
                    for i in range(len(arrival_ids_chunk)):   
                            if Search_range_width == 0:
                                departure_searches.append({"id":departure_id+"-"+ str(uuid.uuid1()),"departure_location_id":departure_id,"arrival_location_ids":arrival_ids_chunk[i],"transportation":transpotations,"departure_time":travel_time,"properties":prop })
                            else:
                                departure_searches.append({"id":departure_id+"-"+ str(uuid.uuid1()),"departure_location_id":departure_id,"arrival_location_ids":arrival_ids_chunk[i],"transportation":transpotations,"departure_time":travel_time,"properties":prop,"range": {"enabled": True, "max_results": 5,"width": Search_range_width}  })

            else:
                for arrival_id in arrival_ids:
                     for i in range(len(departure_ids_chunk)): 
                         if Search_range_width == 0:
                             departure_searches.append({"id":arrival_id+"-"+ str(uuid.uuid1()),"departure_location_ids":departure_ids_chunk[i],"arrival_location_id":arrival_id,"transportation": transpotations,"arrival_time":travel_time,"properties":prop, })
                         else:
                             departure_searches.append({"id":arrival_id+"-"+ str(uuid.uuid1()),"departure_location_ids":departure_ids_chunk[i],"arrival_location_id":arrival_id,"transportation": transpotations,"arrival_time":travel_time,"properties":prop,"range": {"enabled": True, "max_results": 5,"width": Search_range_width} })

            d=10        
            departure_searches_chunk = [departure_searches[i * d:(i + 1) * d] for i in range((len(departure_searches) + d - 1) // d )] 
    
            for departure_searche in departure_searches_chunk:
                if search_type == "departure":
                    req =RouteParameter(locations,departure_searche,None)
                else:
                    req =RouteParameter(locations,None,departure_searche)
                departure_search_list.append(req.__dict__)
                ApiCount = ApiCount+1            
            parseRequest(departure_search_list,APP_ID,API_KEY,Output_style,customize_endpoint)  
            arcpy.AddMessage("Due to the large amount of features, the request will be chunked in "+str(ApiCount)+" API calls. This may have unexpected consequences on some parameters. Keep an eye on your API usage !")
   
    except Exception:
        arcpy.AddError("Error: No route found.Please try again")
        e = sys.exc_info()[1]
        arcpy.AddError('An error occurred: {}'.format(e.args[0]))
        pass
       # exit(0)     
