import requests
import json
import collections
import arcpy
import os
from JsonParameters import RootObject
from JsonFilterParameters import TimeFilterParam
from filterJsonResponse import TimeFilterResponseParam
import dateutil.parser
import datetime
import uuid
import locale
import json
import urllib.parse
import urllib.request
import pytz
import certifi
from urllib.parse import urlparse



sr = arcpy.SpatialReference(4326)
arrival = None
departure = None
location = None
APP_ID = "d8e9df9d"
API_KEY = "8a062f21f574e7918700ff2feba8fa98"
arcpy.env.overwriteOutput = True

wgs = arcpy.SpatialReference(4326)


parameters = arcpy.GetParameterInfo()
transpotations = {};

scriptPath = sys.argv[0]
toolSharePath = os.path.dirname(os.path.dirname(scriptPath))
dataPath = os.path.join(toolSharePath, 'iGeolise')

parametersList = list()
requestlist = list()

for params in parameters:
    parametersList.append(str(params.value).split(";"))

advParaList = ['','None','UTC','departure','','public_transport','15','NORMAL','None','None','0', '15', '30', '15', '5', '0', '0']
simpleParaList = ['','public_transport','UTC','departure','','15','NORMAL','']


if len(parametersList[0]) == 8:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(simpleParaList[idx])
        paramlist.append(objectlist)
else:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(advParaList[idx])
        paramlist.append(objectlist)



res =  paramlist 

arcpy.AddMessage("Processing algorithm…") 
arcpy.AddMessage("Algorithm 'Routes - Simple' starting…") 
arcpy.AddMessage("Input parameters: {}".format(res)) 
arcpy.AddMessage("TravelTime Plugin Version : 1.0.1")
arcpy.AddMessage("TravelTime Algorithm : TimeFilterAlgorithm")

  

for para in res:
    if len(parameters) == 8 :
        departure_search = para[0].replace("'","")
        search_type = para[3].replace("'","")
        Transportation_type =para[1].replace("'","")
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        travel_time = int(para[5].replace("'","")) * 60
        location_search =  para[6].replace("'","")
        Output_layer =  para[7].replace("'","")
        transpotations["type"] = Transportation_type
        symbology_index = 7
        Search_range_width= 0
        Departure_ID = "OID@"
        location_id = "OID@"
    else:
       
        departure_search =  para[0].replace("'","")
        if para[1] !='None':
            Departure_ID =  para[1].replace("'","")
        else:
             Departure_ID = "OID@"
        search_type =  para[3].replace("'","")
        Time_zone =  para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        Transportation_type = para[5].replace("'","")
        travel_time = int(para[6].replace("'","")) * 60
        location_search = para[7].replace("'","")  
        if para[8] !='None':
            location_id = para[8].replace("'","")     
        else:
             location_id = "OID@"

        Output_layer =para[9].replace("'","")

        transpotations["type"] = Transportation_type
        change_delay = para[10].replace("'","")
        walking_time= para[11].replace("'","")
        driving_time_to_station= para[12].replace("'","")
        cycling_time_to_station= para[13].replace("'","")
        parking_time= para[14].replace("'","")
        boarding_time= para[15].replace("'","")
        Search_range_width= int(para[16].replace("'",""))*60
       
        transpotations["type"] = Transportation_type
        transpotations["pt_change_delay"] = int(change_delay) * 60
        transpotations["walking_time"] = int(walking_time)*60
        transpotations["driving_time_to_station"] = int(driving_time_to_station)*60
        transpotations["cycling_time_to_station"] = int(cycling_time_to_station)*60
        transpotations["parking_time"] = int(parking_time)*60
        transpotations["boarding_time"] = int(boarding_time)*60
        transpotations["Search_range_width"] = int(Search_range_width)*60
        symbology_index = 9

    #tzinfo = arcpy.time.TimeZoneInfo(Time_zone) 
    #Depature_time= Date_time.astimezone(tzinfo)    

    #tzinfo = arcpy.time.TimeZoneInfo(Time_zone)
    #offset = tzinfo.utcoffset(Date_time).total_seconds() / 60 / 60    
    #Depart_arriv_Time= str(Date_time.isoformat()+str(format(offset, '.2f')).replace('.',':'))
    #arcpy.AddMessage(Depart_arriv_Time)

    tzinfo = pytz.timezone(Time_zone)    
    Depart_arriv_Time = (tzinfo.localize(Date_time)).isoformat()

    arcpy.env.overwriteOutput = True

    Req = list ()
    departure_id =list()
    arrival_ids =list()
    arrival_ids_chunk =list()
    departure_searches = list()
    arrival_searches = list()

    def loadJson(jsonResponse,feature,layer):
        layerJson =  json.loads(layer)    
        jsonResult = jsonResponse #.json()
        try:              
            unreachable = list()
            i =0                
            for Jresults in jsonResult['results']:                
                if len(Jresults['locations'])>0:
                    for loc in Jresults['locations']:                    
                        for reqLoc in layerJson['locations']:
                            if reqLoc['id'] == loc['id']:
                                coord = list()
                                coord = [reqLoc['coords']['lng'],reqLoc['coords']['lat']]     
                                try:
                                    loc_id = loc['id'].split('_')
                                    dep_id = Jresults['search_id'].split('_')
                                    if search_type == "departure":
                                        feature.append({"type": "Feature","id": reqLoc['id'],"geometry": {"type": "Point","coordinates":coord},"properties": {"FID":i,"Departure_locations_ID":dep_id[1],"Arrival_locations_id":loc_id[1],"id":loc['id'],"Name":Jresults['search_id'],"reachable":1,"travel_time":loc['properties'][0]["travel_time"] } })
                                    else:
                                        feature.append({"type": "Feature","id": reqLoc['id'],"geometry": {"type": "Point","coordinates":coord},"properties": {"FID":i,"Departure_locations_ID":loc_id[1],"Arrival_locations_id":dep_id[1],"id":Jresults['search_id'],"Name":loc['id'],"reachable":1,"travel_time":loc['properties'][0]["travel_time"] } })
                                    i=i+1
                                except :
                                    arcpy.AddMessage("No record found.") 
                if len(Jresults['unreachable'])>0:
                     for loc in Jresults['unreachable']:
                        for reqLoc in layerJson['locations']:                                                       
                            if reqLoc['id'] == loc:
                                coord = list()
                                coord = [reqLoc['coords']['lng'],reqLoc['coords']['lat']]     
                                try:
                                    loc_id = loc.split('_')
                                    dep_id = Jresults['search_id'].split('_')
                                    if search_type == "departure":
                                        feature.append({"type": "Feature","id": reqLoc['id'],"geometry": {"type": "Point","coordinates":coord},"properties": {"FID":i,"Departure_locations_ID":dep_id[1],"Arrival_locations_id":loc_id[1],"id":loc,"Name":Jresults['search_id'],"reachable":0 ,"travel_time":0} })
                                    else:
                                        feature.append({"type": "Feature","id": reqLoc['id'],"geometry": {"type": "Point","coordinates":coord},"properties": {"FID":i,"Departure_locations_ID":loc_id[1],"Arrival_locations_id":dep_id[1],"id":Jresults['search_id'],"Name":loc,"reachable":0 ,"travel_time":0} })
                                    i=i+1
                                except :
                                    arcpy.AddMessage("No record found.")                               
                i=i+1
                    
            return feature
        except KeyError:
            arcpy.AddError("Feature {}".format(jsonResult))  
            pass


    def parseRequest(requestParameter,APP_ID,API_KEY,customize_endpoint):
        index =uuid.uuid1()
        featureCollections = list()
       
        API_ENDPOINT = customize_endpoint+"/v4/time-filter"
        headers = {
            'Accept': "application/json",
            'X-Application-Id': APP_ID,
            'X-Api-Key': API_KEY,
            'Content-Type': "application/json",
            'User-Agent' : "ArcGIS Pro v1.0"
            }
        feature = list()
        featureCollection = list()
        for request in requestParameter:
            endpoint=urlparse(customize_endpoint)
            try :
                if endpoint.scheme=='https':
                    #arcpy.AddMessage(logFilePath)
                    #logging.basicConfig(level=logging.DEBUG)
                    req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                    arcpy.AddMessage(req)
                    res = json.loads(urllib.request.urlopen(req,cafile=certifi.where()).read().decode('utf-8'))
                    features = loadJson(res,feature,json.dumps(request))
                elif endpoint.scheme=='http':
                    #arcpy.AddMessage(logFilePath)
                    #logging.basicConfig(level=logging.DEBUG)
                    req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                    arcpy.AddMessage(req)
                    res = json.loads(urllib.request.urlopen(req).read().decode('utf-8'))
                    features = loadJson(res,feature,json.dumps(request))
            except Exception:
                e = sys.exc_info()[1]
                arcpy.AddError('An error occurred: {}'.format(e.args[0]))
                exit(0)
            
        featureCollection.append({"type":"FeatureCollection","features":features})       
        
        outputFilePath =  os.path.join(dataPath, 'output.json')
        with open(outputFilePath,'w+') as f:
            json.dump(featureCollection[0], f)
   
        try:                
            results = arcpy.JSONToFeatures_conversion(outputFilePath,Output_layer,'POINT')
            layerName = (arcpy.Describe(Output_layer)).baseName            
            p = arcpy.mp.ArcGISProject('CURRENT')
            m = p.listMaps('Map')[0]        
            m.addDataFromPath(Output_layer)
            lyr = m.listLayers(layerName)
            for l in lyr:                    
                 if l.name == layerName:
                      sym = l.symbology  
                      if sym.renderer.type == 'SimpleRenderer':
                          arcpy.AddMessage(layerName)
                          sym.updateRenderer('UniqueValueRenderer')
                          sym.renderer.fields = ['reachable']
                          #sym.renderer.symbol.applySymbolFromGallery("Extent Transparent Wide Gray") 
                          for grp in sym.renderer.groups:

                                for itm in grp.items:
                                    grp.heading = "Reachable/Unreachable"
                                    transVal = itm.values[0][0] #Grab the first "percent" value in the list of potential values                                    
                                    if str(itm.values[0][0]) == str(0):
                                        itm.heading = ''
                                        itm.symbol.applySymbolFromGallery("Star 3")
                                        itm.symbol.size = 16
                                        #itm.symbol.outlineColor = {'CMYK' : [25, 50, 75, 25, 100]}
                                        itm.symbol.color = {'RGB': [178,178,178, 100]}
                                        itm.label = 'Unreachable'
                                    else:
                                        itm.symbol.heading = ''
                                        itm.symbol.applySymbolFromGallery("Star 3")
                                        itm.symbol.size = 16
                                        #itm.symbol.outlineColor = {'CMYK' : [25, 50, 75, 25, 100]}
                                        itm.symbol.color = {'RGB': [0, 227, 0, 100]}
                                        itm.label = 'Reachable'
                      
                      l.symbology = sym
            
            feature = list()
            featureCollection = list()
        except:
            arcpy.AddError("Failed to renderer Symbology.Please try again")
            e = sys.exc_info()[1]
            arcpy.AddError('An error occurred: {}'.format(e.args[0]))
        
   
    

    def createJson(APP_ID,API_KEY,customize_endpoint):
        departure_ids=list()
        departure_id =list()
        arrival_ids =list()
        Source = list()
        arrivallist = list()
        prop = list(["travel_time"])
        locations = list()
        departureList=list()
        ## arrival searches
        for row in arcpy.da.SearchCursor(location_search, ["OID@", "SHAPE@",location_id]):
            if row[2] == ' ':                
                id_search = "searches_" + str(row[0])
            else:
                id_search = "searches_" + str(row[2])
            pnt_wgs = row[1].projectAs(wgs)
            #id_search = "searches" + str(row[0])
            arrival_ids.append(id_search)
            departure_id.append(id_search)
            arrivallist.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
            locations.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})

        n=2000
        m=2000
        final = [locations[i * m:(i + 1) * m] for i in range((len(locations) + m - 1) // m )]
        arrival_ids_chunk = [arrival_ids[i * n:(i + 1) * n] for i in range((len(arrival_ids) + n - 1) // n )]        
        reuest_list = list()

        ####departure searches
        departure_search_list = list()
        for row in arcpy.da.SearchCursor(departure_search, ["OID@", "SHAPE@",Departure_ID]):
            if row[2] == ' ':                
                depature_search_id = "Location_" + str(row[0])
            else:
                depature_search_id = "Location_" + str(row[2])
            #depature_search_id = "Location" + str(row[0])
            departure_ids.append(depature_search_id)
            pnt_wgs = row[1].projectAs(wgs)
            abcd = list()
            departureList.append({"id":depature_search_id,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})
            locations.append({"id":depature_search_id,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y}})

        n=2000
        m=2000
        dfinal = [departureList[i * m:(i + 1) * m] for i in range((len(departureList) + m - 1) // m )]  
        departure_ids_chunk = [departure_ids[i * n:(i + 1) * n] for i in range((len(departure_ids) + n - 1) // n )]  
       
        if search_type == "departure":
            for departure_id in departure_ids:
                for i in range(len(arrival_ids_chunk)):
                    s_id = departure_id+"_"+ str(i)
                    if Search_range_width == 0:
                        departure_searches.append({"id":s_id,"departure_location_id":departure_id,"arrival_location_ids":arrival_ids_chunk[i],"transportation":transpotations,"departure_time":Depart_arriv_Time, "travel_time": travel_time,"properties":prop })                
                    else:
                        departure_searches.append({"id":s_id,"departure_location_id":departure_id,"arrival_location_ids":arrival_ids_chunk[i],"transportation":transpotations,"departure_time":Depart_arriv_Time, "travel_time": travel_time,"properties":prop,"range": {"enabled": True,"max_results":5,"width": Search_range_width} })                
        else:
             for arrival_id in arrival_ids:
                for i in range(len(departure_ids_chunk)):  
                    s_id = arrival_id+"_"+ str(i)
                    if Search_range_width == 0:
                        departure_searches.append({"id":s_id,"arrival_location_id":arrival_id,"departure_location_ids":departure_ids_chunk[i],"transportation":transpotations,"arrival_time":Depart_arriv_Time, "travel_time": travel_time,"properties":prop })
                    else:
                        departure_searches.append({"id":s_id,"arrival_location_id":arrival_id,"departure_location_ids":departure_ids_chunk[i],"transportation":transpotations,"arrival_time":Depart_arriv_Time, "travel_time": travel_time,"properties":prop ,"range": {"enabled": True,"max_results":5,"width": Search_range_width}})

        d=10
        departure_searches_chunk = [departure_searches[i * d:(i + 1) * d] for i in range((len(departure_searches) + d - 1) // d )]
       
        ApiCount =0
        for departure_searche in departure_searches_chunk:            
            if search_type == "departure":
                req =TimeFilterParam(locations,departure_searche,None)
            else:              
               req =TimeFilterParam(locations,None,departure_searche)
            departure_search_list.append(req.__dict__)
            ApiCount = ApiCount+1

        parseRequest(departure_search_list,APP_ID,API_KEY,customize_endpoint)

        arcpy.AddMessage("Due to the large amount of features, the request will be chunked in "+str(ApiCount)+" API calls. This may have unexpected consequences on some parameters. Keep an eye on your API usage !")

    aprx = arcpy.mp.ArcGISProject("CURRENT")
    authenticatoinFilePath =  os.path.join(toolSharePath, 'Authentication.json') # "..//Authentication.json"
    try:
        with open(authenticatoinFilePath) as f:
          data = json.load(f)      
          if  '' in [data['Api_key'], data['App_id']]:
              arcpy.AddError("Error: You need a TravelTime platform API key to make requests. Please head to http://docs.traveltimeplatform.com/overview/getting-keys/ to obtain one, and enter it in the plugin's setting dialog.")
              exit(0)
          else:
             APP_ID =  data['App_id']
             API_KEY = data['Api_key']
             customize_endpoint = data['customize_endpoint']
             createJson(APP_ID,API_KEY,customize_endpoint)
    except Exception:
        arcpy.AddError("Error:No records found.Please try again")
        exit(0)


