import requests
import json
import collections
import arcpy
import os
from JsonParameters import RootObject
from JsonRouteParameters import RouteParameter
from jsonResponse import ResponseParameters
from TimeMapRequest import TimeMapParams
import dateutil.parser
import datetime
import uuid
import locale
import json
import urllib.parse
import urllib.request
import pytz
import certifi
from urllib.parse import urlparse



APP_ID = "d8e9df9d"
API_KEY = "8a062f21f574e7918700ff2feba8fa98"
cur_locale = locale.getlocale()
locale.setlocale(locale.LC_TIME, cur_locale)

sr = arcpy.SpatialReference(4326)

arrival_searches = None
data =  {
  "departure_searches": [],
  "arival_searches": []
  }

wgs = arcpy.SpatialReference(4326)
parameters = arcpy.GetParameterInfo()
transpotations = {};

scriptPath = sys.argv[0]
toolSharePath = os.path.dirname(os.path.dirname(scriptPath))
dataPath = os.path.join(toolSharePath, 'iGeolise')



parametersList = list()
requestlist = list()
for params in parameters:
    parametersList.append(str(params.value).split(";"))



advParaList = ['','name','UTC','departure','','public_transport','15','NORMAL','','0', '15', '30', '15', '5', '0', '0']
simpleParaList = ['','public_transport','UTC','departure','','15','NORMAL','']


if len(parametersList[0]) == 8:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(simpleParaList[idx])
        paramlist.append(objectlist)
else:
    paramlist = list()
    count = len(parametersList[0])
    for x in range(count):
        objectlist = list()
        for idx, data in enumerate(parametersList):
            if x < len(data): 
                 objectlist.append(data[x])
            else:
                objectlist.append(advParaList[idx])
        paramlist.append(objectlist)



res =  paramlist

arcpy.AddMessage("Processing algorithm…") 
arcpy.AddMessage("Input parameters: {}".format(res)) 
arcpy.AddMessage("TravelTime Plugin Version : 1.0.1")
arcpy.AddMessage("TravelTime Algorithm : TimeMapAlgorithm")  


## generzte parameter
for para in res:    
    if len(para) == 8 :
        departure_search = para[0].replace("'","")
        search_type = para[3].replace("'","")
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        Transportation_type = para[1].replace("'","")
        travel_time =int(para[5].replace("'",""))*60
        Result_Aggression = para[6].replace("'","")
        Output_layer = para[7].replace("'","")
        symbology_index = 7
        transpotations["type"] = Transportation_type
        Search_range_width= 0
    else :
        departure_search = para[0].replace("'","")
        Departure_ID = para[1].replace("'","")
        search_type = para[3].replace("'","")
        Time_zone = para[2].replace("'","")
        Date_time = dateutil.parser.parse(para[4].replace("'",""))    
        Transportation_type = para[5].replace("'","")
        travel_time =int(para[6].replace("'",""))*60
        Result_Aggression = para[7].replace("'","")
        Output_layer = para[8].replace("'","")
        symbology_index = 8
        change_delay = para[9].replace("'","")
        walking_time= para[10].replace("'","")
        driving_time_to_station= para[11].replace("'","")
        cycling_time_to_station= para[12].replace("'","")
        parking_time= para[13].replace("'","")
        boarding_time= para[14].replace("'","")
        Search_range_width= int(para[15].replace("'",""))*60

        transpotations["type"] = Transportation_type
        transpotations["pt_change_delay"] = int(change_delay)*60
        transpotations["walking_time"] = int(walking_time)*60
        transpotations["driving_time_to_station"] = int(driving_time_to_station)*60
        transpotations["cycling_time_to_station"] = int(cycling_time_to_station)*60
        transpotations["parking_time"] = int(parking_time)*60
        transpotations["boarding_time"] = int(boarding_time)*60
        

    #tzinfo = arcpy.time.TimeZoneInfo(Time_zone)
 
    #Depart_arriv_Time= Date_time.astimezone(tzinfo)

    tzinfo = pytz.timezone(Time_zone)    
    Depart_arriv_Time = (tzinfo.localize(Date_time)).isoformat()
    didList = []
    #for did in Departure_ID:
         #arcpy.AddMessage(did)
         


    def loadJson(jsonResponse,feature):
        jsonResult = jsonResponse #.json()        
        try:
            
            if Result_Aggression == "UNION":
               
                for Jresults in jsonResult['results']:            
                    if "unions" in Jresults["search_id"]: 
                        geom = list()
                        for loc in Jresults['shapes']:            
                            coord = list()
                            coordHoles = list()
                            for parts in loc['shell']:
                                geometry = [parts['lng'],parts['lat']]
                                coord.append(geometry)
                            for holesparts in loc['holes']:
                                coordHoles = list()
                                for parts in holesparts:
                                    geometry = [parts['lng'],parts['lat']]
                                    coordHoles.append(geometry)
                                geom.append(coordHoles)
                            geom.append(coord)
                        try:                        
                            feature.append({"type": "Feature","id": "destination","geometry": {"type": "Polygon","coordinates":geom},"properties": {}})                           
                        except :
                            arcpy.AddError("Error")
            elif Result_Aggression == "INTERSECTION":
                
                 for Jresults in jsonResult['results']:                    
                    if  "intersection" in Jresults["search_id"]:
                        geom = list()
                        for loc in Jresults['shapes']:            
                            coord = list()
                            coordHoles = list()
                            for parts in loc['shell']:
                                geometry = [parts['lng'],parts['lat']]
                                coord.append(geometry)
                            for holesparts in loc['holes']:
                                coordHoles = list()
                                for parts in holesparts:
                                    geometry = [parts['lng'],parts['lat']]
                                    coordHoles.append(geometry)
                                geom.append(coordHoles)
                            geom.append(coord)                        
                        try:
                            if not any(geom):
                                arcpy.AddMessage("No Intersections found.")                            
                            else:                                
                                feature.append({"type": "Feature","id": "destination","geometry": {"type": "Polygon","coordinates":geom},"properties": {}})                               
                        
                        except :
                            arcpy.AddMessage("No record found.")
            else :
                
                coord = list()
                coordHoles = list()

                for Jresults in jsonResult['results']:                              
                    geom = list()
                    for loc in Jresults['shapes']:            
                        coord = list()
                        coordHoles = list()
                        for parts in loc['shell']:
                            geometry = [parts['lng'],parts['lat']]
                            coord.append(geometry)
                        for holesparts in loc['holes']:
                            coordHoles = list()
                            for parts in holesparts:
                                geometry = [parts['lng'],parts['lat']]
                                coordHoles.append(geometry)
                            geom.append(coordHoles)
                        geom.append(coord)
                    
                    try:                    
                        feature.append({"type": "Feature","id": "destination","geometry": {"type": "Polygon","coordinates":geom},"properties": {}})                       
                    except :
                        arcpy.AddError("Result is empty.Please try again")

            return feature
        except KeyError:
            arcpy.AddError("Feature {}".format(jsonResult))  
            pass



    def parseRequest(requestParameter,APP_ID,API_KEY,customize_endpoint):
        index =uuid.uuid1()
        featureCollections = list()
       
        API_ENDPOINT = customize_endpoint+"/v4/time-map"
        headers = {
            'Accept': "application/json",
            'X-Application-Id': APP_ID,
            'X-Api-Key': API_KEY,
            'Content-Type': "application/json",
            'User-Agent' : "ArcGIS Pro v1.0"
            }
        feature = list()
        featureCollection = list()        
        for request in requestParameter:
            endpoint=urlparse(customize_endpoint)
            try :
                if endpoint.scheme=='https':
                    #arcpy.AddMessage(logFilePath)
                    #logging.basicConfig(level=logging.DEBUG)
                    req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                    res = json.loads(urllib.request.urlopen(req,cafile=certifi.where()).read().decode('utf-8'))
                    features = loadJson(res,feature)
                elif endpoint.scheme=='http':
                    #arcpy.AddMessage(logFilePath)
                    #logging.basicConfig(level=logging.DEBUG)
                    req = urllib.request.Request(API_ENDPOINT, json.dumps(request).encode('utf-8'), headers = headers)
                    arcpy.AddMessage(req)
                    res = json.loads(urllib.request.urlopen(req).read().decode('utf-8'))
                    features = loadJson(res,feature)
            except Exception:
                    e = sys.exc_info()[1]
                    arcpy.AddError('An error occurred: {}'.format(e.args[0]))
                    #exit(0)

        if not features:
            arcpy.AddError("Feature {}".format("No records found") )            
        else:
            featureCollection.append({"type":"FeatureCollection","features":features})  
            outputFilePath =  os.path.join(dataPath, 'output.json')
            with open(outputFilePath,'w') as f:
                json.dump(featureCollection[0], f)
            arcpy.env.overwriteOutput = True
            try:
                if Result_Aggression == "NORMAL":
                    results = arcpy.JSONToFeatures_conversion(outputFilePath,Output_layer)
                    arcpy.RepairGeometry_management(Output_layer)
                    pointLyrPath = os.path.join(dataPath, 'TimeMapSymbol.lyrx')
                    params = arcpy.GetParameterInfo()
                    desc = arcpy.Describe(Output_layer)                
                    params[symbology_index].symbology = pointLyrPath
                    feature = list()
                    featureCollection = list()
                else:
                    results = arcpy.JSONToFeatures_conversion(outputFilePath,Output_layer+"1" )
                    arcpy.RepairGeometry_management(Output_layer+"1" )
                    arcpy.Dissolve_management(Output_layer+"1", Output_layer,"OBJECTID")                    
                    pointLyrPath = os.path.join(dataPath, 'TimeMapSymbol.lyrx')
                    params = arcpy.GetParameterInfo()
                    desc = arcpy.Describe(Output_layer)                
                    params[symbology_index].symbology = pointLyrPath
                    feature = list()
                    featureCollection = list()
                
            except Exception:
                arcpy.AddError("No record found.Please Try again")
                e = sys.exc_info()[1]
                arcpy.AddError('An error occurred: {}'.format(e.args[0]))
           
                              

    def createJson(APP_ID,API_KEY,customize_endpoint):

        arrival_searches=None
    
        departure_id =list()
        arrival_ids =list()
        deapartureSearch= list()
        arrivalSearch = list()
        departure_search_list = list()   
        ApiCount =0
        for row in arcpy.da.SearchCursor(departure_search, ["OID@", "SHAPE@"]):
       
            pnt_wgs = row[1].projectAs(wgs)
            id_search = "Location" + str(row[0])
            arrival_ids.append("Location" + str(row[0]))
            departure_id.append(id_search)
            if search_type == "departure":
                if Search_range_width == 0:
                    deapartureSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"departure_time": Depart_arriv_Time,"travel_time":travel_time})
                else:
                    deapartureSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"departure_time": Depart_arriv_Time,"travel_time":travel_time,"range": {"enabled": True,"width": Search_range_width}})
            else:
                if Search_range_width == 0:
                    arrivalSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"arrival_time": Depart_arriv_Time,"travel_time":travel_time})
                else:
                    arrivalSearch.append({"id":id_search,"coords" : { "lng" : pnt_wgs.centroid.X, "lat":pnt_wgs.centroid.Y },"transportation":transpotations,"arrival_time": Depart_arriv_Time,"travel_time":travel_time,"range": {"enabled": True,"width": Search_range_width}})
        d=10 
        union_chunk = [departure_id[i * d:(i + 1) * d] for i in range((len(departure_id) + d - 1) // d )] 
        union =list()
        for i in range(len(union_chunk)):
            union.append({"id":"unions"+str(i),"search_ids":union_chunk[i]})
    
        intersection =list()
        for i in range(len(union_chunk)):
            intersection.append({"id":"intersection"+str(i),"search_ids":union_chunk[i]})
   
        if search_type == "departure":
            departure_searches_chunk = list()
            departure_searches_chunk = [deapartureSearch[i * d:(i + 1) * d] for i in range((len(deapartureSearch) + d - 1) // d )] 
            i=0            
            departure_search_list = list() 
            for departure_searche in departure_searches_chunk:                
                searchids =list()
                searchids.append(union[i])
                intersection_searchids =list()
                intersection_searchids.append(intersection[i])
                if Result_Aggression == "UNION":
                    req =TimeMapParams(departure_searche,None,searchids,None)
                elif Result_Aggression == "INTERSECTION":
                    req =TimeMapParams(departure_searche,None,None,intersection_searchids)
                else:
                    req =TimeMapParams(departure_searche,None,None,None)
                i = i+1;      
                ApiCount = ApiCount+1
                departure_search_list.append(req.__dict__)
            parseRequest(departure_search_list,APP_ID,API_KEY,customize_endpoint)
        else:
            arrival_searches_chunk = [arrivalSearch[i * d:(i + 1) * d] for i in range((len(arrivalSearch) + d - 1) // d )] 
            i=0            
            departure_search_list = list() 
            for arrival_searche in arrival_searches_chunk:                
                searchids =list()
                searchids.append(union[i])
                intersection_searchids =list()
                intersection_searchids.append(intersection[i])
                if Result_Aggression == "UNION":
                    req =TimeMapParams(None,arrival_searche,searchids,None)
                elif Result_Aggression == "INTERSECTION":
                    req =TimeMapParams(None,arrival_searche,None,intersection_searchids)
                else:
                    req =TimeMapParams(None,arrival_searche,None,None)
                i = i+1;      
                ApiCount = ApiCount+1
                departure_search_list.append(req.__dict__)
            parseRequest(departure_search_list,APP_ID,API_KEY,customize_endpoint)
        arcpy.AddMessage("Due to the large amount of features, the request will be chunked in "+str(ApiCount)+" API calls. This may have unexpected consequences on some parameters. Keep an eye on your API usage !")

        departure_id =list()
        arrival_ids =list()
        deapartureSearch= list()
        arrivalSearch = list()
        departure_search_list = list()   

  ### authentication  starting point
    authenticatoinFilePath =  os.path.join(toolSharePath, 'Authentication.json') # "..//Authentication.json"
    aprx = arcpy.mp.ArcGISProject("CURRENT")
   
    try:
        with open(authenticatoinFilePath) as f:
          arcpy.AddMessage("Checking authnentication")  
          data = json.load(f)      
          if  '' in [data['Api_key'], data['App_id']]:
              arcpy.AddError("Error: You need a TravelTime platform API key to make requests. Please head to http://docs.traveltimeplatform.com/overview/getting-keys/ to obtain one, and enter it in the plugin's setting dialog.")
              exit(0)
              #APP_ID = "d8e9df9d"
              #API_KEY = "8a062f21f574e7918700ff2feba8fa98"
              #createJson(APP_ID,API_KEY,customize_endpoint)
          else:
             APP_ID =  data['App_id']
             API_KEY = data['Api_key']
             customize_endpoint = data['customize_endpoint']
             createJson(APP_ID,API_KEY,customize_endpoint)
    except Exception:
        arcpy.AddError("Error: No record found.Please try again")
        exit(0)
    
